clash-lib-1.8.1: Clash: a functional hardware description language - As a library

Copyright | (C) 2012-2016 University of Twente (C) 2021 QBayLogic B.V.
License | BSD2 (see the file LICENSE)
Maintainer | QBayLogic B.V. <devops@qbaylogic.com>
Safe Haskell | Safe-Inferred
Language | Haskell2010

Clash.Normalize.Strategy

Description

Transformation process for normalization

Synopsis

- normalization :: NormRewrite
- constantPropagation :: NormRewrite
- topdownSucR :: Rewrite extra -> Rewrite extra
- innerMost :: Rewrite extra -> Rewrite extra
- applyMany :: [(String, Rewrite extra)] -> Rewrite extra

# Documentation

normalization :: NormRewrite Source #

Normalisation transformation

constantPropagation :: NormRewrite Source #

topdownSucR :: Rewrite extra -> Rewrite extra Source #

Topdown traversal, stops upon first success

innerMost :: Rewrite extra -> Rewrite extra Source #

applyMany :: [(String, Rewrite extra)] -> Rewrite extra Source #